 function Abnormal(inputfilename,pauselen,draw_cluster,pauslen_draw)


% The tracks.<date>.txt file is the output of the tracking component.

% It defines a structure with each field representing a single trajectory.

% A trajectory is a two dimensional array (an array of points).

% (note: ideally, this output should be a .mat file instead )

% Auther : Gurkirt Singh

% Date   : 15 April 2010



% Input file name%

system(['cp ',inputfilename,' tmp.m']);

tmp

% output file name



% Get the 'references' to all the trajectories

% (here the structure name is <code>TRACKS</code>).

fn=fieldnames(TRACK);
load Covars6
load means6
controlPointsNumber=6;
degree=3;

clusters=cell(13);

for n = 1 : length(fn)
    
    traj=TRACK.(fn{n});
    StartArea=AreaNumber(traj(1,1:2));
    EndArea=AreaNumber(traj(end,1:2));
    mu=means{StartArea,EndArea};
    sigma=covars{StartArea,EndArea};
    
    % fitting splinme process start
    
    [x y] = transformForSplines(traj, 640, 460);
    
    len = size(y,1);
    
    [xcp,ycp] = splinefit(x, y, controlPointsNumber, degree);
    
    Cpoints=[xcp', ycp'];
    % Reconstruct the spline given its control points.
    [xr,yr] = splinerec(xcp,ycp,len,degree);
    
    deviation=0;
    
    z=[x y]-[xr yr];
    
    %        size(mu,1) will greater than zero only when path is modelled
    %        if path is not modelled that mean this abnormal trajectory
    if (size(mu,1)>0)
        
        for i=1:len
            
            deviation=deviation+(norm(z(i,:)))^2;
            
        end
        
        deviation=sqrt(deviation/len);
        
        probability= mvnpdf(Cpoints,mu,sigma);
        P_log=log(probability);
        
        z=Cpoints-mu;
        
        Vectdiff=norm(z);
        
        
        if  ( deviation>.038 || Vectdiff>.44 || (P_log<-20 && deviation>.006 && Vectdiff>.37))
[n,length(fn)]           
            if pauselen>0
            close all;
            
            open('small.fig');
            
            hold on
            
            plot(round(640*x), round(y*460), 'b-');
            
            hold on;
            
            plot(round(640*xcp),round(460*ycp),'k:o');
            
            hold on;
            
            plot(round(640*xr),round(460*yr),' r-');
            title('It is abnormal trajectory')
            pause(pauselen);
            end
        else 
            clusters{StartArea,EndArea}(end+1,1:12)= Cpoints;
        end
    else
        if pauselen>0
        close all;
        
        open('small.fig');
        
        hold on
        
        plot(round(640*x), round(y*460), 'b-');
        
        hold on;
        
        plot(round(640*xcp),round(460*ycp),'k:o');
        
        hold on;
        
        plot(round(640*xr),round(460*yr),' r-');
        
        title('It is abnormal trajectory')
        
        pause(pauselen);  %             badtrajectories{i,j}=trajectories;
        end
    end
    
end
save clusters clusters
if draw_cluster==1
    for i=1:13
        for j=1:13
            
            cluster=clusters{i,j};
            
            if size(cluster,1)>0
                close all
                open('small.fig');
                hold on
                colors = ['rgbcmyk'];
                for n=1:size(cluster,1)
                    xcp=cluster(n,1:6)';
                    ycp=cluster(n,7:12)';
                    [nn,mm] = size(colors);
                    colorNo = mod(n-1, mm) + 1;
                    [xr yr]= splinerec(xcp,ycp,len,degree);
                    plot(round(xr*640),round(yr*460),[colors(colorNo),'-']);
                    hold on
                end
                pause(pauslen_draw);
            end
        end
    end
end
