% Transforms the values of the trajectory points to fall into <0,1>
% (required by the <code>splinefit</code> function).
% 
% It also removes points which are very close to each other -
% if a person was standing in one place through the whole of its
% existence, there is no point in fitting a spline,
% even when spatial approximation is used.
%
% traj: 2-dimensional array of trajectory points
% maxX, maxY: dimensions of an image from the camera
% dist: min distance between consecutive points
function [x,y] = transformForSplines(traj, maxX, maxY)

% traj = removeClosePositions(traj, dist);

x = traj(:,1);
x = x ./ (maxX);

y = traj(:,2);
y = y ./ (maxY);